#undef ARM
#define ARM 1

/*
 * The following definitions assure the C compilers are defined with
 * the correct logical values for #if directives. The definitions
 * they use come from the C command line.
 */

#define DeBug
#define Standard
#define FixedRegions
#define SystemFnc
#define KeyboardFncs
#define CStateSize 25
#define Pipes
#define ArmFncs

#define HostStr "Acorn Archimedes (RISC OS 2.00)"

/*
 * More configuration parameters.
 */

#define Precision 15
#define IconAlloc
#define index strchr
#define rindex strrchr

/*
 * Assign Archimedes-standard names for the Icon predefined
 * environment variables.
 */

#define MEMMON		"Icon$MemMon"
#define NOERRBUF	"Icon$NoErrBuff"
#define TRACE		"Icon$Trace"
#define COEXPSIZE	"Icon$CoExpSize"
#define STRSIZE		"Icon$StrSize"
#define HEAPSIZE	"Icon$HeapSize"
#define BLOCKSIZE	"Icon$BlockSize"	/* Synonyms */
#define BLKSIZE		"Icon$BlkSize"		/* Synonyms */
#define STATSIZE	"Icon$StatSize"
#define STATINCR	"Icon$StatIncr"
#define MSTKSIZE	"Icon$MStkSize"
#define QLSIZE		"Icon$QLSize"
#define ICONCORE	"Icon$Core"

/*
 * Note that the default IPATH is "Icon: Lib:Icon.", so that it is better
 * to define Icon$Path (using the standard Archimedes path conventions,
 * using comma-separated prefixes), rather than redefining Icon$IPath,
 * which uses Icon's own conventions (space-separated prefixes).
 */

#define IPATH		"Icon$IPath"
