/*
 *  Icon configuration. This file is produced when the Icon system is
 *  set up.
 */

/*
 *  A number of symbols are defined here.  Some are specific to individual
 *  to operating systems.  Examples are:
 *
 *	MSDOS		MS-DOS for PCs
 *	UNIX		any UNIX system
 *	VMS		VMS for the VAX
 *
 *  These are defined to be 1 or 0 depending on which operating system
 *  the installation is being done under.  They are all defined and only
 *  one is defined to be 1.  (They are used in the form #if VAX || MSDOS.)
 *
 *  There also are definitions of symbols for specific computers and
 *  versions of operating systems.  These include:
 *
 *	PCIX		code specific to the IBM PC under PC/IX
 *	SUN		code specific to the Sun Workstation
 *	LATTICE		code specific to the Lattice C compiler for MS-DOS
 *
 *  Other definitions may occur for special configurations. These include:
 *
 *	DeBug		debugging code
 *	MemMon		color-graphics memory monitoring
 *	RunStats	run-time statistics gathering
 *	TranStats	translator statistics gathering
 *
 *  Other definitions perform configurations that are common to several
 *  systems. Examples are:
 *
 *	Double		align reals at double-word boundaries
 *	ZeroDivide	enable C code to test for division by real zero.
 *
 */

/*
 *  The following definitions are system-specific.
 */

/*
 *  The following signals are common to MS-DOS and all UNIX systems. (They are
 *  different for VAX/VMS.)
 */
#define NormalExit	0
#define ErrorExit	1

/*
 *  Between here and the following bar of equal signs is where most 
 *  modifications should be made for parameters and constants that vary
 *  from one compiler to another.
 *
 *  =======================================================================
 */

/*
 *  The following definitions are system-specific.
 */

/*
 * This section choses values depending on whether the compilation is
 * being done for the small or large memory model.
 *
 */

#define IntSize 32
#define PtrSize 32
#define LongSize 32
#define FixedRegions
#define HostStr "Atari ST (GEMDOS) Lattice C 3.04.01 (e)"
#define Fork fork
#define index strchr
#define rindex strrchr
#define Hz 50
#define NoHeader 1
#define EnvVars
#define TraceBack
#define IconGcvt
/*
#define NoCoexpr
#define NoOver
#define NoEnvVars
*/

#define ATARI_ST 1

/*
 *  This ends the region where parameters and constants may need changing
 *  for different C compilers.
 *
 *  =======================================================================
 */


/*
 * Set up typedefs and related definitions depending on whether or not
 * ints and pointers are the same size.
 */

#if IntSize != PtrSize
#define MixedSizes
#endif

#ifdef MixedSizes
typedef long int word;
typedef unsigned long int uword;
#define atoi atol
#else
typedef int word;
typedef unsigned int uword;
#endif

/*
 *  The following definitions depend on whether or not the ANSI C standard
 *  is supported.
 */

#ifdef Standard
#define Cat(x,y) x##y
#define Lit(x) #x
typedef void *pointer;
#else					/* Standard */
#define Ident(x) x
#define Cat(x,y) Ident(x)y
#define Lit(x) "x"
typedef char *pointer;
#endif					/* Standard */

#ifndef PORT
#define PORT 0
#endif					/* PORT */

#ifndef AMIGA
#define AMIGA 0
#endif					/* AMIGA */

#ifndef ATARI_ST
#define ATARI_ST 0
#endif					/* ATARI_ST */

#ifndef MACINTOSH
#define MACINTOSH 0
#endif					/* MACINTOSH */

#ifndef MSDOS
#define MSDOS 0
#endif					/* MSDOS */

#ifndef MVS
#define MVS 0
#endif					/* MVS */

#ifndef UNIX
#define UNIX 0
#endif					/* UNIX */

#ifndef VM
#define VM 0
#endif					/* VM */

#ifndef VMS
#define VMS 0
#endif					/* VMS */
