/************************************************************************/
/*									*/
/*	MICRO C-Shell for the Atari ST					*/
/*	Written by David Beckemeyer					*/
/*									*/
/*	(C) Copyright 1985						*/
/*	David Beckemeyer						*/
/*	All Rights Reserved						*/
/*									*/
/*	Unauthorized Duplication Prohibited				*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <xdos.h>
#include <osbind.h>

#define TRUE	1
#define FALSE	0

struct basepage {
	char *ltpa;
	char *htpa;
	char *lcode;
	long codelen;
	char *ldata;
	long datalen;
	char *lbss;
	long bsslen;
	char *dta;
	char *parent;
	long rsvd;
	char *env;
};

extern struct basepage *_base;


/* locate variable name in environment string */
static char *findenv(s)
char *s;
{
	char name[20];
	char *p;

	if (s) {
		strcpy(name, s);
		strcat(name, "=");
	}
	for (p = _base->env; *p; p++) {
		if (s) {
			if (strcmp(p, name) == 0)
				break;
		}
		while (*p)
			p++;
	}
	return(p);
}


	
putenv(s)
char *s;
{
	char name[20];
	char *n, *p, *t, *old, *new;
	long i;
	char *findenv();

	/* get the name from caller's data */
	for (p = name; *s; p++, s++)
		if ((*p = *s) == '=')
			break;
	if (*s++ == '\0')
		return(-1);
	if (*s == '\0')
		return(-1);
	*p = '\0';

	/* address variable name or end of env */
	t = p = findenv(name);

	/* skip past definition, address remainder of env (if any) */
	if (*t) {
		/* skip past variable name */
		while (*t)
			t++;
		/* skip past string data (if any) */
		t++;
		if (*t) {
			while (*t)
				t++;
			t++;
		}
	}
	/* compute size of required string */
	i = (p - _base->env) + (findenv(0L) - t) + strlen(s)+strlen(name) + 4L;
	if ((n = new = Malloc(i)) == 0)
		return(-1);
	for (old = _base->env; old != p; )
		*new++ = *old++;
	strcpy(new, name);
	strcat(new, "=");
	while (*new)
		new++;
	strcpy(++new, s);
	while (*new)
		new++;
	for (t, old = findenv(0L), new++; t != old; )
		*new++ = *t++;
	*new = '\0';
	Mfree(_base->env);
	_base->env = n;
	return(0);
}


char *getenv(name)
char *name;
{
	char *p;

	p = findenv(name);
	if (*p) {
		while (*p)
			p++;
		return(++p);
	}
	return(NULL);
}
