	page	80,132
comment %
**************************************************************************
***  (c) Copyright 1983 - 1990            MetaWare Incorporated.       ***
**************************************************************************
***  You have the same rights to the object form of this program as    ***
***  you do to the object code of the library.  You may not distribute ***
***  this source, even if modified by you.                             ***
**************************************************************************
***  The source to this module is provided for the convenience of      ***
***  MetaWare Pascal and High C users that need to tailor their        ***
***  execution environments.  The casual user should NOT play with the ***
***  code. This code is subject to change without notice in future     ***
***  releases of the compilers.                                        ***
**************************************************************************
***  You must preserve the library copyright notice defined in this    ***
***  module if your program uses any portion at all of the run-time    ***
***  library (including this initializer or any other supplied run-    ***
***  time source).  The copyright notice is in the definition of       ***
***  the initial stack segment.  We recommend it be left right there.  ***
***  But you can move it to anywhere you want as long it appears in    ***
***  any linked program (.exe or ROM-burned program) using the library.***
**************************************************************************


      MetaWare Pascal or High C Runtime Initialization Module
                   for small model, protected mode 386.


 --------------------------------------------------------------------------
  This initializer supports:
 --------------------------------------------------------------------------
  a. Pharlap's 386 DOS|Extender, run386.
  b. A.I. Architect's (Eclipse) OS/386 DOS extender.

 --------------------------------------------------------------------------
  Assembly instructions:
 --------------------------------------------------------------------------
  By default, the code assumes the use of 386asm.  If your would like to
  use MASM, you must define USING_MASM later in the defines section.

 --------------------------------------------------------------------------
  Differences between Pascal and C run-time initialization:
 --------------------------------------------------------------------------
  In C, the argv array must be allocated and computed.  In Pascal argument
  processing is handled through a separate argument pacakge.

 --------------------------------------------------------------------------
  Defines that you can set:
 --------------------------------------------------------------------------
  1. USING_MASM.  Set this if you are using MASM to assemble this file.
  2. HC.  Set if this is for the High C library; not set otherwise.
  3. STACK_SIZE.  Set this to the size of the stack you want.
  4. no87.  Set this if you know you have no 8087 or 287.  It will eliminate
       the initialization code for the chip.
       Also, it will remove the printing of the "no87" environment variable
       if you have an 8087/287 and the no87 variable is set to non-blank string.
       (Don't confuse the "no87" define in this assembly from the no87
       MS-DOS environment variable.  Read the programmer's Guide for more info
       on the latter.)
       Another reason to set this variable is that you know you're never
       going to use an 8087/287, even if you have one.  It's especially
       useful to remove the printing of the no87 environment variable on
       programs for which the 8087/287 processor is irrelevant.
  5. DOS.   Set this if this initializer is for MS-DOS (default).  Unset it
       for embedded applications where DOS doesn't exist.  If you unset it,
       you won't get argc/argv for C, nor the arg package for Pascal.
       It doesn't remove all of the DOS-dependent code -- some of it you must
       still rewrite for embedded applications (like how to find the top of
       memory).  (By "unset" we mean just comment out the line setting it!)
       Note that unsetting DOS doesn't remove all DOS-dependent code in
       the library.  For example, the interrupt handler initialization
       uses INT 21h, and so does all I/O.  Read the Embedded Applications
       section of the Programmer's Guide for more information about how
       to change those modules (source is generally provided).
  6. IGC_exists  -- Set when IGC environment is possible.
       Unsetting it comments out code dependent on that environment only.
  7. PL_exists  -- Set when PharLap DOS|Extender environment is possible.
       Unsetting it comments out code dependent on that environment only.
  8. NOWTK      -- Set if either the Weitek 1167 will never be present or
       if you never care about it.
  9. PHAR_LAP_CAN_GROW_HEAP. Phar Lap's DOS|Extender 1.1t or later can grow
       the heap dynamically. For enabling Phar Lap DOS|Extender to grow the
       heap dynamically, ; uncomment the next line.
 10. AIA_CAN_GROW_HEAP. For Lahey-linked programs, we assume expansion can
       occur, since such linked programs do not give you all of memory.


Set the appropriate defines in the init.def module, and then assemble
  -- init.asm, init_co.asm, and init_fp.asm --

 --------------------------------------------------------------------------
  Memory Layout:
 --------------------------------------------------------------------------

 High memory   +---------------+
               | END OF MEMORY |
               |---------------|
               | top-of-heap   |
               |   ...         |
               | bottom-of-heap|
  _TOP  ->     |---------------|  <- Of size STACK_SIZE, unless there isn't
               |   stack       |  <- room, in which case the first heap
               |   ...         |  <- allocation will fail.
               | end-of-stack  |
  _BASE ->     +---------------+
               DATA   segments   (static variables and named common)
 Low memory    CODE   segments
 See the programmer's guide for more information and pictures of
 run-time organization with the different memory models.
 Stack margin1 is 512 bytes above the true end-of-stack.
 Stack margin2 is 256 bytes above the true end-of-stack.
 In non-large models, the stack margins go in a reserved area in the data
 segment, not in the stack segment.  In the large model, since there is
 no single data segment, the stack margins go at the tail end of the stack
 (at ss:-2 and ss:-4).

 If stack overflow checking is enabled, here is the code that is generated:
       For procedures using 256 or less bytes in the stack:
               cmp     esp,Stack_margin_1
               jnb     around
               int     0
       around: ...

       Since Stack_margin_2 is 512 above true e-o-s, such procedures will always
       leave at least 256 bytes (512-256) left in the stack.

       For procedures that use more than 256 bytes:
               mov     eax,esp
               sub     eax,Stack_margin_2
               cmp     eax,Amount_to_allocate
               jae     around
               int     0
       around: ...

       Since Stack_margin1 is 256 from true end,
       such procedures will leave at least 256 bytes in the stack.

    Therefore, stack overflow occurs when less than 256 bytes would be
    left AFTER stack allocation.
    This permits the run-time environment to do some processing
    such as producing a trace or cleaning up.
%

;---------------------------------------------------------------------------
; Start of program code.
;---------------------------------------------------------------------------
	.386p		; Need p to execute "lsl" to determine limit
			; of data segment.
	.287
	name    init
	include	init.def	; defaults moved into init.def
;				  several assemblies use them.
;				  init.asm, init_co.asm init_fp.asm
if CATSPAW EQ 0
	; The following include file is provided by IGC.
	; GDA.STR is general data area structure for VM/RUN (X-AM).
	; Upon entry to target program from VMRUN, EDX --> GDA.
	; GDA is not useful when solely in the Phar-Lap environment.
	; Use "gda.h" in the inc/ directory to access the GDA from C:
	;
	; 	#include "gda.h"
	;	GDA *gdaptr;
	include gda.str
endif
;--------------------------------------------------------------------------
;  Fix segment ordering.
;--------------------------------------------------------------------------
    ; The following dummy segment instructs linker to put "code" lowest
    ; Must be made public since the main module also has public code,
    ; and some primitive linkers can't handle segments of the same name
    ; with different privacy attributes.  (This does not include Phar Lap's
    ; linker.)

;-- code segment ----------------------------------------------------------
if CATSPAW EQ 0 OR ICON
CODE    segment dword public 'CODE'
CODE    ends

;-- data segment ----------------------------------------------------------
DATA    segment dword public 'DATA'
        pubname stack_limit
The_stack_margin equ this word
def     stack_limit,dd,0        	; Stack margins.
        dd      0
DATA    ends

;-- bss segment ----------------------------------------------------------
_BSS	segment	public 'BSS'		; Must occur before stack.
_BSS	ends
endif

;-- stack segment ----------------------------------------------------------
; Use dword alignment for stack segment in the future.

?STACK  segment  dword stack  'STACK'   ; of at least 80 bytes.
; Copyright message got moved out of here so that the stack wouldn't
; take up space in the .exe file.

start_of_stack equ this byte
        db      STACK_SIZE dup (?)	; The default stack of 8K.
if SPITBOL
end_of_stack   equ this byte
endif
?STACK  ends    			; MS-DOS loader puts info at the
					; tail end of the stack during loading.
if SPITBOL
; Force heap to start at 4K boundary.
; This gives us some room below for code/data expansion and still have
; SPITBOL heap load at the same location during restarts.
HEAP	segment	page4k 'HEAP'
heap_start	label	dword
HEAP	ends
endif


;---------------------------------------------------------------------------
;  Line terminator convention.
;---------------------------------------------------------------------------
    ; This must be a MetaWare Pascal string:  2 bytes for the length,
    ; then the actual string characters follow.
    ; Even if the string is of length one, leave the length of this
    ; segment at 8 bytes. (leave lt2 present even if not used.)
    ; Line termination convention for input:

_MWLTCONV       segment common dword 'DATA'
ltconv_in       dw      2       ; length is 2 for line terminator.
				; zero says allow either char for line term.
lt1i            db      13      ; CR
lt2i            db      10      ; LF
; Line termination convention for output; must be length of one or two chars.
ltconv_out      dw      2       ; length is 2 for line terminator.
lt1o            db      13      ; CR
lt2o            db      10      ; LF
_MWLTCONV       ends

;---------------------------------------------------------------------------
;  Call on entry segments
;---------------------------------------------------------------------------
    ; This segment is used to 'register' functions which must be called
    ; by the start-up routine.  Each of the functions to be called
    ; contain the following three segments, of which the first and last
    ; are empty. The central segment contains zero or more pointers to
    ; routines that the initializer must call during startup.
ifdef	HC
_mwinitfrstcall	segment	public word 'DATA'
_mwinitfrstcall	ends
_mwinitmustcall	segment	public word 'DATA'
_mwinitmustcall	ends
_mwinitlastcall	segment	public word 'DATA'
_mwinitlastcall	ends
endif

;--------------------------------------------------------------------------
;  Start of data segment.
;--------------------------------------------------------------------------
dseg    segment dword 'DATA'

    ;----------------------------------------------------------------------
    ;  Public symbol declarations.
    ;----------------------------------------------------------------------
        ; The symbols declared with the defequ or pubnames macros are
        ; prefixed with "_mw".  Input and output are for Pascal but must be
	; provided in C if we link in the C initializer with Pascal routines.

        pubnames <input,output>
        pubnames <es,is_286,envp,8087,387,1167>
        pubnames <argp,arglen,prognamep>
        pubnames <CPU,OS,env>
	pubnames <emc87,heap_expansion_enabled>
        extrn   _osmajor:byte,_osminor:byte
	ifdef   HC
        pubname argvp
	endif

	; Define input and output descriptors
	; Pascal file variables Input and Output.
	; They are initialized in Pascal's Finit.p.

defequ  input,dw,0
defequ  output,dw,1

    ;----------------------------------------------------------------------
    ;  Initialize the "host" package.
    ;----------------------------------------------------------------------
        ; Initialize the "host" package that identifies the system we're
        ; running on.  See the interface file Host.pf distributed with
        ; Professional Pascal or High C for the enumerated type declaration
        ; for the values of CPU and OS.

defequ  CPU,db,8        ; Indicates 386.
defequ  OS,db,0         ; Indicates MSDOS.

    ;----------------------------------------------------------------------
    ;  Initialize the graphics selector.
    ;----------------------------------------------------------------------
        ; The startup code detects the host environment and sets the graphics
	; selector accordingly.  This info is used by GFX.

defequ	gsel,dw,0	; graphics selector
public	_mwgsel 	; Pharlap (PL_env) uses 1C
			; Eclipse (AI_env) uses B8 and B0

    ;----------------------------------------------------------------------
    ;  Data definitions.
    ;----------------------------------------------------------------------

STDERR  equ     2      		; standard error file handle
_psp    equ     this byte
def     es,df,0
	; The contents of es prior to invoking program
        ; df is Microsoft's way of saying 48-bit pointer;
        ; Phar Lap uses dp or df.
escontents equ _psp             ; Program segment prefix pointer.
envptr  equ 2CH       		; Offset in DOS ctrl block where env address
				; is located

ifdef   STACK_SIZE
        public  _top,_base,_psp
_top    dd      0               ; Top of stack (relative to SS).
_base   dd      0               ; Base of stack (relative to DS).
_heaphi dd      0
ifdef   IGC_exists
        public  _gda
_gda    dd      0               ; Address of gda (softguard only)
endif
endif

defequ  argp,df,?       	; Pointer to command arguments
ifdef HC
defequ  argvp,df,?       	; Address of argv array for C.
endif

        even
defequ  arglen,DD,?     	; Length of command argument string
defequ  envp,df,0       	; Pointer to environment string
if	SPITBOL
	pubnames <getenvbp,getenvbz>
	public	_environ
_environ dd	envtemp
envtemp	dd	0
defequ	getenvbp,dd,0	;Pointer to near buffer for getenv
defequ	getenvbz,dd,MAXENVS ;size of buffer
endif
defequ  is_286,db,0     	; True if this is a 286.

_8087   equ     this word       ; Need word to store control word into.
def     8087,dw,0       	; Set to true if 8087 is present
	db	0dh,0ah,'80x87$'
temp    dw      0

_387    equ     this word       ; Need word to store control word into.
def     387,dw,0        	; Set to true if 80387 is present.
	db	0dh,0ah,'80387$'

_1167   equ     this word
def     1167,dw,0       	; True if 1167 is present.

_emc87	equ	this word
def	emc87,dw,0	; Set to true if emc87 is present.
	db	0dh,0ah,'Cyrix EMC87$'

	public	_mwno87
_mwno87	dd	0		;pointer to no87 environment string.
_mwno87es dw	0,0	;MUST immediately follow mwno87!!!!!!
savefs	dw	0
Null_pname db   0       	; Null prog name for < DOS 3.0.

; Prognamep is initialized to a 32-bit pointer to a 0-byte in case
; we can't obtain the program name.
defequ  prognamep,dd,Null_pname	; Pointer to program name
        prognamep_seg dw 0

return_address equ this byte	; Used to save the return address before the
return_off	dd	0	; stack is set up.  We can then use a jump
return_seg	dw	0	; instruction to return.

SG_ENV = 1
PL_ENV = 2
AI_ENV = 3
defequ  env,db,0        	; Which environment are we in?  SG/PL/AI?
cur_pages dd 0  		; Current # pages allocated: Phar Lap.
Lahey_format_load_file db 0     ; .plx (Phar-Lap linked) by default.

CANT_EXPAND = 0
CAN_EXPAND = 1
defequ	heap_expansion_enabled,db,CAN_EXPAND  	; Is heap expandable? 

dseg    ends

ifdef   DOS
  if SPITBOL
DGROUP  group _MWLTCONV,_mwinitfrstcall,_mwinitmustcall,_mwinitlastcall,dseg,?STACK,HEAP
  else
DGROUP  group DATA,_MWLTCONV,_mwinitfrstcall,_mwinitmustcall,_mwinitlastcall,dseg,_BSS,?STACK
  endif
else
DGROUP  group DATA,_MWLTCONV,_mwinitfrstcall,_mwinitmustcall,_mwinitlastcall,dseg,?STACK
endif

;--------------------------------------------------------------------------
;  Start of code segment.
;--------------------------------------------------------------------------
?init   segment dword 'CODE'
if SPITBOL
CGROUP	group	?init
else
CGROUP  group   ?init,CODE
endif
        assume cs:CGROUP

    ;---------------------------------------------------------------------------
    ;  Declare external procedures
    ;---------------------------------------------------------------------------
    ; Extern procs must be defined within current code segment for
    ; correct relocation bits to be generated.
    ; Phar lap assembler won't take next line; it plays according to the rules
    ; (as opposed to Microsoft's assembler):

extrn   exit:near
ifdef   HC
    extrn   main:near       ; Main program entry point
    extequ  set_up_args,near; Routine to compute argv pointers.
else
    extequ  main,near       ; Main program entry point
endif

    ; Where are the stack margins defined?  Top of stack or in data segment?

if CATSPAW EQ 0 OR ICON
Stack_margin_big_place	 equ     dword ptr DGROUP:The_stack_margin
Stack_margin_small_place equ     dword ptr DGROUP:The_stack_margin+Word_size
endif

    ;-------------------------------------------------------------------------
    ;  Here begins the execution of a Professional Pascal or High C program.
    ;-------------------------------------------------------------------------

init    proc
        publab  INIT    ; Compiler generates this in upper case.
	; INIT: Initialization code
	; - set initial stackpointer, framepointer
	; - jump to _CINIT function to continue initialization.
        assume  ds:DGROUP
	ifdef   HC
	Small_data_HC = 1
	endif
	SETBLOCK equ 4Ah

	jmp	Start_init
	public	__main
__main:
	jmp	main

Start_init:

	; DOS|Extender environment discovery code obtained from Phar Lap:
ifdef   IGC_exists
	; IGC: eax = abcdabcd.  Also, code segment is privilege level 3
	; (= 43 hex).
	cmp     al,0cdh         ; eax = abcdabcd for IGC.
	jne     short not_sg
	cmp     ah,0abh
	jne     short not_sg
	; Flaw: If we are in non-protected mode and get this far,
	; the cmp eax will have 16 bits too much constant, and will
	; cause the initializer to bomb.  It is unlikely that ax=abcd
	; yet eax <> abcdabcd.  --fixed with shift sequence.
;;;	cmp     eax,0abcdabcdh  ; Now try 386 instruction.
	shr	eax,8
	cmp	ah,0cdh
	jne     short not_sg
	shr	eax,8
	cmp	ah,0abh
	jne     short not_sg
	mov     env,SG_ENV
	mov     _gda,edx
	jmp     short Initialize_everything
endif
not_sg: mov     env,PL_ENV

Initialize_everything:
	sub     ebp,ebp         ;Initialize stack frame pointer
	; Make sure stack is mod 4 in case it's not.
	and     esp,0fffffffch  ; Drop extra bytes.  Oh well.
	assume  ds:DGROUP
if CATSPAW EQ 0 OR ICON
	; For the 386 we own all of memory.  Size up memory and inform the
	; heap manager.
	mov     Stack_margin_big_place,Stack_margin_big
	mov     Stack_margin_small_place,Stack_margin_small
	add     Stack_margin_big_place,offset start_of_stack
	add     Stack_margin_small_place,offset start_of_stack
endif
ifdef  IGC_exists
	cmp     env,SG_ENV
	je      short SG_STACK
endif
ifdef  PL_exists
	mov     _base,0         ; Start of stack.
  if SPITBOL
	lea	eax,heap_start	; SPITBOL - Heap starts at 4K boundary
	mov	_top,eax
  else
	lea     eax,32[esp]     ; eax = start of heap + some padding for safety.
	mov     _top,eax	; CATSPAW - was esp instead of eax

;	mov     ax,ds		; CATSPAW - remove
;	lsl     eax,eax         ; load segment limit of data segment.
  endif
	mov     _heaphi,eax     ; Top of heap (linear address).
	mov	ax,fs
	mov	savefs,ax
	and     ax,ax   	; If fs = 0 (Lahey linker), can't have Weitek.
	sete    Lahey_format_load_file
endif
ifdef   IGC_exists
	jmp     short more_init1
SG_STACK:
	; Initialize stack, IGC environemnt.
	; This code will work for h (highest) and a (append after load)
	; stk options. esp already setup by vmrun loader.
	mov     eax,esp         	; get stack pointer
	mov     ecx,[edx].GDA_STKSZ     ; get stack size, kbytes
	shl     ecx,10          	; convert from k to # of bytes
	sub     eax,ecx         	; calculate base of stack addr
	mov     _base,eax       	; stack base
	mov     eax,[edx].GDA_HLOD      ; get highest load address
	mov     _top,eax        	; bottom of heap
	mov     ecx,[edx].GDA_HMEM      ; get available high memory
	shl     ecx,10          	; convert from k to # of bytes
	add     eax,ecx         	; calculate heap top addr
	mov     _heaphi,eax     	; top of heap
	; Free memory below 640K for subsequent use by EXEC.
	mov     ebx,[edx].GDA_TLOW      ; Subtract highest used low address.
	sub     ebx,[edx].GDA_PSPA      ; Subtract lowest used low address.
	shr     ebx,4                   ; Convert to paragraphs.
	inc     ebx                     ; Safety?
	mov     ah,SETBLOCK             ; SETBLOCK to bx paragraphs from
	; psp start.
	int     21h
	test    byte ptr [edx].GDA_ENV,GDA_WEITEK
	setne   byte ptr _1167
endif
more_init1:
	extrn	_cinit:near
	jmp	_cinit
init	endp

ifdef HC
	db      'High C'
else
	db      'Professional Pascal'
endif
	db      ' Run-time Library Copyright (C) 1983-1990 MetaWare Incorporated.'


ifdef   DOS
;-------------------------------------------------------------------------------
; init_env_area()
;-------------------------------------------------------------------------------
    ; Process environment area and parameter strings.

init_env_area proc
	publab init_env_area
	assume	cs:CGROUP
	assume	ds:DGROUP

	Parm_string_offset = 80h       	; Offset in PSP containing parm
					; string (len+bytes).
					; Pop return address off of stack
	pop	dword ptr return_off
	ifdef	Small_data
	push	cs			; 32 bits?
	endif
	pop	eax			; Two instructions to maintain
	mov	word ptr return_seg,ax	; stack alignment!!!!!!
	;
	;pop	word ptr return_seg  >>>; resulted in a misaligned stack
	;			     >>>; w/ great performance degradation.

	cld                    		; All moves are forward
ifdef  IGC_exists
	cmp     env,PL_ENV
	je      short PL_PSP

	; GDA has pointer to PSP.  PSP has env seg, which, shifted left by 4,
	; yields the 32 bit address of the env.
        mov     edi,[edx].GDA_PSPA      ; Get flat PSP address.
        mov     word ptr argp+Word_size,ds
        mov     dword ptr _psp,edi
        mov     word ptr _psp+Word_size,ds
        lea     eax,Parm_string_offset[edi] ; eax = pso+edi.
        xor     ebx,ebx
        mov     bl,[eax]       		; Get length of parm string.
        mov     arglen,ebx
        inc     eax
        mov     dword ptr argp,eax      ; Addr of parm string.
        mov     bx,envptr[edi]  	; Get segment address of
					; environment pointer.
        shl     ebx,4           	; Convert to 32-bit flat address.
        mov     dword ptr envp,ebx
        mov     word ptr envp+Word_size,ds ; Fill out 48-bit address
        jmp     short more_init2
PL_PSP:
endif

ifdef   PL_exists
PSPseg  equ     24h     ; Pointer to DOS's Program segment prefix: Phar Lap.
ENVseg  equ     2ch     ; Pointer to DOS's environment string: Phar Lap.
        cmp     Lahey_format_load_file,1
        je      short ES_points_to_PSP_already
        mov     ax,PSPseg
        mov     bx,cs
        arpl    ax,bx
        mov     es,ax           		; Load es with psp address.
        ; Load environment segment into cx.
        mov     cx,ENVseg
        arpl    cx,bx
        jmp     short more
ES_points_to_PSP_already:
        ; Load environment segment into cx.
        mov     cx,es:02ch
        mov     ax,es
more:
        mov     word ptr _psp+Word_size,ax      ; Construct 48-bit psp address.
        mov     word ptr escontents+Word_size,ax; No displacement
        mov     word ptr envp+Word_size,cx	; Environment segment.
        xor     eax,eax
	push	eax
        mov     al,es:Parm_string_offset 	; Length of parm string
        mov     arglen,eax

; In C, the parameter string must be moved to a DS-accessible area
; if small-data model.
ifdef   HC
; Move the parm string into the stack so that it can be accessed by
; small-data programs with only 16-bit pointers.
        mov     ecx,eax 	; parameter length
	inc	ecx
        add     al,3
        and     al,0fch 	; Make sure eax is multiple of 4.
        sub     esp,eax  	; Length of parm string.
        mov     edi,esp  	; Move the parameter string here.
        mov     dword ptr argp,edi ; Save address of args.
        ;push    edx     	; Allow byte for parm string overwrite
				; by C arg processor.  But make stack
				; word-aligned for efficiency.
        push    ds      	; Save it.
        push    es      	; source is es:81h
        pop     ds
        push    es      	; Save es.
        push    ss
        pop     es      	; Dest is ss:di.
        mov     esi, offset Parm_string_offset+1
        rep     movsb   	; es:di := parm string.
        pop     es
        pop     ds
else
; Large-data or Pascal model	; just store the address of the parms.
        mov     ax,word ptr escontents+Word_size
        mov     word ptr argp+Word_size,ax
        mov     dword ptr argp,Parm_string_offset+1     ; Addr of parm string.
endif
endif
more_init2:

; In DOS 3.0 and higher, the program name is stored at the end of the
; environment variable area, terminated by a 0 byte.
; We need to discover DOS version to see if we should get the pname.
        sub     eax,eax
        mov     ah,30h			; Get DOS version number
        int     21h
        mov     word ptr _osmajor,ax    ; Moves minor (AH) and major (AL).
        cmp     env,SG_ENV
        je      short no_change
        shr     eax,16
        cmp     ax,'DX'
        jne     short to_ai
; Phar Lap.
ifndef  PHAR_LAP_CAN_GROW_HEAP
        jmp     short no_change
else
        ; Now free all of the heap, so that we
	; allocate more only when necessary.
    if SPITBOL
	lea	ebx,heap_start
    else
        mov     ax,4
        mov     es,ax
        mov     ebx,es:[5ch]            ; Initial size of heap: load image size in bytes.
                                        ; See Phar Lap TN #21.
    endif
        jmp     short Free_up
endif
to_ai:
        mov     env,AI_ENV
        mov     ebx, _top               ; Top of stack in bytes
ifndef  AIA_CAN_GROW_HEAP
        cmp     Lahey_format_load_file,1
        jne     short no_change
        ; If Lahey format, we must be able to grow.
endif
Free_up:
  if CATSPAW
	shr	ebx,12			; Convert to 4K pages
	mov	cur_pages, ebx
    if  ICON
	add	ebx,4095		; Catspaw, 4/23/91
    endif
  else
        add     ebx,4095                ; Round up to pages.
        shr     ebx,12                  ; Convert to 4K pages.
        inc     ebx                     ; Add 1 page for initial heap.
        mov     cur_pages, ebx
        mov     edx, ebx
        shl     edx,12                  ; Future value for heaphi.
  endif
        cmp     env,PL_ENV
        je      short No_para
        shl     ebx, 8                  ; Convert to paragraphs for AIA.
No_para:
        push    ds
        pop     es                      ; Segment to free up.
        mov     ah,SETBLOCK             ; SETBLOCK to bx paragraphs from psp start.
	push	es			; CATSPAW - SETBLOCK bashes ES if fails
        int     21h
	pop	es
  if CATSPAW EQ 0
        jc      short no_change         ; If couldn't get the extra page, oops!
        mov     _heaphi,edx
  endif
no_change:


Find_prog_name:
;     -- Format of DOS environment:              VVV 3.x only VVV
;     -- t1 nul t2 nul t3 nul ... tn nul nul x x program-name nul
; Go to end of environment string to get program name for DOS 3.0.
; While we're doing so, see if he said "NO87=" something, in which case,
; mimicking Microsoft's emulator, we print the string (unless it's
; nothing but blanks), and disable use
; of the 80287 if the combination emulation/80287 library is linked in.
        les     edi,envp        ; Pointer to environment area.
        xor     eax,eax         ; search for 0 byte.
Scan_again:
        cmp     dword ptr es:[edi],'78ON'   ; NO87
        jne     short not1
        cmp     byte ptr es:4[edi],'='   ; =
        jne     short not1

; All this fuss just to print the NO87 string!
ifndef  no87
	add	edi,5
	mov	_mwno87,edi
	mov	_mwno87es,es	;save pointer and print it later.
endif   ; no87

not1:   sub     ecx,ecx         ; This is shorter than mov ecx,-1
        dec     ecx
;       mov     ecx,-1          ; Search lotsa bytes.
        repnz   scasb           ; Search for 0.
; We MUST have found the 0 byte; we're positioned at the byte after.
        cmp     byte ptr es:[edi],0     ; Two 0 bytes in a row?
        jne     Scan_again      ; Nope, keep going.
; Now we've found the environment area end.  +3 bytes later is the prog name.
        add     edi,3           ; Move to program name.
        cmp     _osmajor,3      ; Program name supplied by OS?
        jb      short NO_PNAME_AVAIL
        cmp     env,SG_ENV
        jne     short get_pname
        cmp     env,AI_ENV
        je      short get_pname
        ; IGC: pname is addressable.
        mov     dword ptr prognamep,edi
        mov     word ptr prognamep+Word_size,ds
        jmp     short _prog_name

NO_PNAME_AVAIL:
; No program name.  Supply the null string.
ifdef   HC
; Allocate the null byte on the stack right after the parms.
        xor     edx,edx
        push    edx             ; Null byte(s).
        mov     dword ptr prognamep,esp  ; Pointer to the program name.
endif
        jmp     short _prog_name

get_pname:
ifdef  PL_exists
PL_PN:
; In small-data C, the program name must be moved into the DS group.
ifdef   Small_data_HC           ; Move the program name to the stack.
        mov     ax,es
        lsl     eax,eax         ; load segment limit of env string.
        xor     eax,eax
        ; Find length of program name.
        sub     ecx,ecx
        dec     ecx
;       mov     ecx,-1
        mov     ebx,edi         ; Save starting address of name.
        repnz   scasb
        sub     edi,ebx         ; Length of name (including 0 trailer).
        lea     eax,3[edi]      ; Add some space on stack...
;;        and     eax,0fffch      ; Ensure mod 4 for nice value for SP.
	and	al,0fch		;only al involved, so use shorter instructions.
        sub     esp,eax         ; Allocate space for name.
        mov     dword ptr prognamep,esp  ; Where the name will be put.
        mov     ecx,edi         ; Length of name
        mov     esi,ebx         ; Name is stored here.
        mov     edi,esp         ; Copy to here.
        push    ds
        mov     ds,word ptr envp+Word_size
        push    ss
        pop     es
        rep     movsb
        pop     ds
else
        ; Non-small data case:  just record the address.
        mov     dword ptr prognamep,edi
        mov     word ptr prognamep+Word_size,es
endif
endif
_prog_name:
ifdef HC
       ; Now allocate the space for the argv pointers.  One for the program name
       ; and one for each argument.  Although we don't know how many arguments
       ; there are, there can be at most 1 for every two characters of the
       ; environment string.
	mov     eax,arglen
	inc     eax
	shr     eax,1   ; Max arg ptrs for parameters
	inc     eax     ; Count the program name.
	inc     eax     ; ANSI requires argv[argc] = null pointer.
	shl     eax,2   ; Multiply by pointer size
	sub     esp,eax ; Now allocate it.
	mov     dword ptr argvp,esp      ; sp is here.
endif   ; HC

if SPITBOL
;
; SPITBOL cannot use mwinit_environ to setup access to environment block.
; Instead, we allocate a MAXENVS-byte buffer that will be used by
; getenv() to selectively copy out strings from the environment found
; from the far pointer in _mwenvp.
;
	push	MAXENVS
	call	sbrk
	mov	_mwgetenvbp,eax	; save for use by getenv
endif

if MANY_FILES
;
;**************************************************************
;       allocate a full 256-byte area of file handles
;	if running under Phar Lap.  Code added by Catspaw, Inc.
;**************************************************************
;
  ifdef  PL_exists
        cmp     env,PL_ENV
        jne	Init_return		; not PharLap
; Here for Phar Lap
	mov	ax, 25c0h		; allocate convential memory
	mov	bx, 16			; 16 paras = 256 bytes
	int	21h
	jc	Init_return		; Insufficient memory
	and	eax,0ffffh		; clean segment address
	mov	ebx,eax			; bx = new segment
	shl	eax,4			; True 20-bit offset
	mov	edi,eax
	mov	eax,34h			; segment to map low 1 Mb of mem
	mov	es,ax			; es:edi points to 256 byte area
	push	ds			; save ds
	push	edi			; save edi
	cld
	mov	ecx,256
	mov	al,0ffh			; mark all entries as free
   rep	stosb				; fill
	pop	edi			; es:edi = new handle area
	mov	eax,24h			; PSP selector
	mov	ds,ax			; ds:0 = PSP
; Stupid Phar Lap assembler seems to have a problem with storing into
; absolute locations.   Do it the hard way
	mov	eax,32h			; PSP word with number of handles
	mov	ecx,256
	xchg	cx,[eax]		; Load/set number of handles

	inc	eax
	inc	eax
	xor	edx,edx
	xchg	dx,[eax]		; Load/set offset of handle table

	inc	eax
	inc	eax
	xchg	bx,[eax]		; Load/set segment of handle table

	shl	ebx,4			; convert to 20-bit address
	add	ebx,edx
	mov	esi,ebx			; es:esi=old handle table
	push	es
	pop	ds
  rep	movsb				; copy old handle table into new
	pop	ds
	push	ds
	pop	es			; restore es,ds
  endif
endif
Init_return:
	jmp	fword ptr return_address
init_env_area endp

endif   ; DOS


;-------------------------------------------------------------------------------
; call_onentry_fcns()
;-------------------------------------------------------------------------------
call_onentry_fcns proc
	publab	call_onentry_fcns
	prolog

        assume  ds:DGROUP
        push    ds
        pop     es
        ; ss is already = ds.

	;
	; Clear BSS segment
	;
	ifdef	USING_BSS
	extrn	_edata:near
	extrn	_end:near

	xor	eax,eax
	mov	edi,offset _edata
	mov	ecx,offset _end
	sub	ecx,edi
	rep	stosb
	endif

	;
	; Call file and user initialization
	;
	mov	ebx,offset ds:_mwinitfrstcall
	mov	ecx,offset ds:_mwinitlastcall
	sub	ecx,ebx			;size of the pointer array.
mustcall:	or	ecx,ecx		;all pointers been called?
	jz	mustdone		;yes.
	mov	edi,[ebx]		;get next pointer.
	add	ebx,4			;bump to next pointer.
	sub	ecx,4			;decr count.
	mov	fs,savefs		;set to initial value, in case
					; clobbered. init_67 needs it.
	ifndef	Small_code
	mov	esi,[ebx]		;get the segment too.
	add	ebx,2			;and adjust pointer and count.
	sub	ecx,2
	endif
	or	edi,edi			;null pointer?
	jz	mustcall		;yes, so skip it.
	push	ebx			;save my regs.
	push	ecx
	ifdef	Small_code
	call	edi			;call the routine pointed to.
	else
	push	edi			;put the address on the stack.
	push	esi
	mov	ebx,esp
	call	dword ptr [ebx]		;do a far call to the routine.
	pop	ecx
	pop	ecx
	endif
	pop	ecx
	pop	ebx
	jmp	mustcall		;keep it up until all done.

mustdone:

	;
	; Set graphics selector _mwgsel according to the environment
	; and equipment configuration. 
	;
	cmp	env,PL_ENV		;Is this Pharlap's environment?
	je	short PL_sel
	cmp	env,AI_ENV		;OS386?
	jne	selector_is_set
AI_sel:
	mov	ah,12h			;OS386 has different selectors
	mov	bl,10h			;for color and bw.
	int	10h			;ask the BIOS which it is
	and	bh,bh
	jz	color
b_and_w:
	mov	gsel,0b0h		;OS386 bw selector is 0xb0
	jmp	short selector_is_set
color:
	mov	gsel,0b8h		;OS386 color selector is 0xb8
	jmp	short selector_is_set
PL_sel:
	mov	gsel,1ch		;Pharlap uses 0x1c
selector_is_set:

	epilog
call_onentry_fcns endp


; Next three routines are used by sysalloc and sysfree.

;--------------------------------------------------------------------------
;      function Heaplo(): Cardinal;  ; Returns bottom of heap space.
;--------------------------------------------------------------------------
;       This function returns the starting segment of the heap.
;       This is determined by the address of variable ??heap, since
;       MS-DOS loader don't otherwise tell you where your program ends.
;       Therefore ??heap must be located at the end of your link map;
;       if it precedes code, the heap manager will allocate heap in the
;       middle of your program!
;       If the stack precedes the heap, then heaplo is just above the
;       stack.

        db      0
heaplo proc     near
        publab  heaplo
        ; return ss:_top; paragraph if non-small-data model.
        mov     eax,_top
if CATSPAW EQ 0 
        add     eax,16
endif
        return
heaplo endp

;--------------------------------------------------------------------------
;       function Heaphi(): Cardinal;  ; Returns top of heap space.
;--------------------------------------------------------------------------
;       This returns the estimated top of the area that can be used
;       for the heap.  This top area depends somewhat on whether
;       memory is tight.  If there is plenty of memory, the heap top
;       is 1K below the stack bottom.  If memory is tight, the heap
;       top is within 256 bytes of the stack bottom.
;       On the other hand, if the stack precedes the heap, heaphi
;       is just the top of memory.

        db      0
heaphi  proc    near
        publab  heaphi
        mov     eax,_heaphi
        return
heaphi  endp

; The heap manager calls this routine to expand the heap when it
; detects a heap overflow.  The expansion expands allocates more memory
; starting at _heaphi.  Record the new top-of-heap in _heaphi.
; Currently this is implemented only for Phar Lap's DOS|Extender.
expand_heap proc near
        publab  expand_heap
        push    ebx
        ; Has the user shut off heap expansion?  
        cmp	heap_expansion_enabled,CANT_EXPAND
        je	short Cant_grow
        cmp     env,PL_ENV
ifndef  PHAR_LAP_CAN_GROW_HEAP
        je      short Cant_grow ; Must have release >= 1.1t.
else
        je      short Can_grow
endif
ifndef  AIA_CAN_GROW_HEAP
        cmp     Lahey_format_load_file,1
        jne     short Cant_grow
        ; If Lahey format, we must be able to grow.
else
        cmp     env,AI_ENV
        jne     short Cant_grow
endif
Can_grow:
if CATSPAW
        mov     eax,8[esp]      ; Request for more bytes.
	add	eax,_heaphi	; New end address
	cmp	eax,_top
	jb	short Cant_grow	; Too small
	mov	ebx,eax
	add	ebx,4095	; Round to pages.
	shr	ebx,12
	cmp	ebx,cur_pages	; Any change?
	je	short ok_as_is
	push	eax		; save end address
else
        mov     ebx,8[esp]      ; Request for more bytes.
        add     ebx,4095        ; Round to pages.
        shr     ebx,12
        add     ebx,cur_pages
        inc     ebx             ; Always have 4K of extra room.
endif
        mov     ah,SETBLOCK
        push    ebx             ; Save it.
        cmp     env,AI_ENV
        jne     short pages
        shl     ebx, 8          ; convert to paragraphs for AI.
pages:
	push	es			; CATSPAW - SETBLOCK bashes ES if fails
        int     21h
	pop	es
if CATSPAW
	pop	ebx		; # pages requested.
	pop	eax		; New heaphi
	jc	short Cant_grow
	mov     cur_pages,ebx
ok_as_is:
else
        pop     eax             ; Amount requested.
        jc      short Cant_grow
        mov     cur_pages,eax
        shl     eax,12
endif
        mov     _heaphi,eax
	pop	ebx		; restore ebx
	return
Cant_grow:
	xor	eax,eax		; signal failure
        pop     ebx
	return
expand_heap endp


if CATSPAW
;-------------------------------------------------------------------------
;       procedure sbrk
;-------------------------------------------------------------------------
;
; char *sbrk(int n) - adjust heap limit upward by n bytes.
;
; char *sbrk(int n) {
;   char *p;
;   p = heaphi();			/* Old sbrk value */
;   if (expand_heap(n))
;      return p;
;   else
;      return (char *) -1;
; }

	public	sbrk
sbrk	proc	near
	push	_heaphi			; save old sbrk value
	push	dword ptr 8[esp]	; push n
	call	_mwexpand_heap		; expand_heap pops n
	add	esp,4			; discard argument n
	or	eax,eax
	jne	short sbrk1		; jump if ok
	pop	edx			; discard old sbrk value
	not	eax			; return -1
	ret
sbrk1:	pop	eax			; return old sbrk value
	ret
sbrk	endp


;-------------------------------------------------------------------------
;       procedure brk
;-------------------------------------------------------------------------
;
; int brk(char *p) - set heap limit to fixed value
;
; int brk(char *p) {
;    int n;
;    n = p - heaphi();
;    if (n <= 0) return 0;
;    if (expand_heap(n))
;       return 0;
;    else
;       return -1;
; }
;
	public	brk
brk	proc	near
	mov	eax,4[esp]		; fetch arg p
	sub	eax,_heaphi		; n = p - _heaphi
	jbe	short brk1		; jump if n <= 0
	push	eax
	call	_mwexpand_heap		; expand_heap(n)
	add	esp,4			; discard argument
	or	eax,eax			; test result
	jne	short brk1		; jump if successful
	not	eax			; return -1
	ret
brk1:	xor	eax,eax			; return 0
	ret
brk	endp
endif


;-------------------------------------------------------------------------
;       procedure set_stack_limits(small,large:Cardinal);
;-------------------------------------------------------------------------
;       Set the two limits.
;       This is called by the heap manager when the heap begins to creep
;       into the stack, or when the heap has left the stack area.
;       Basically, when the heap has used the lower portion of the stack,
;       the stack margin variables are set to reflect a higher bottom-of-stack
;       location, so that stack overflow will occur when the stack is within
;       256 bytes of the heap.
;       If the stack precedes the heap, the heap never creeps into the
;       stack and this procedure will never be called.
if CATSPAW EQ 0 OR ICON
Set_stack_limits        proc    far
        publab  set_stack_limits
        return  8
Set_stack_limits        endp

;-------------------------------------------------------------------------
;       function ss: Cardinal; {Returns paragraph address of stack segment
;-------------------------------------------------------------------------
ssx     proc    far
        publab  ss
        mov     ax,ss
        return
ssx     endp
endif
;-------------------------------------------------------------------------
;       function Getds: Cardinal;       -- Returns ds register.
;-------------------------------------------------------------------------
;       This function may actually no longer be needed.
ifdef   Small_data
getds   proc    far
        publab  getds   ; return ds register.
        mov     ax,ds
        return
getds   endp
endif

if SPITBOL EQ 0
_exit   proc    near			;force an immediate exit to dos.
        public  _exit
        mov     eax, esp
        mov     al, [eax+4]
        mov     ah, 4ch
        int     21h
_exit   endp
endif

?init   ends
        end     CGROUP:init
