MAKE=make

OBJS=		tmain.o util.o tlocal.o trans.o err.o tdbase.o tlex.o\
		parse.o tsym.o tmem.o toktab.o tree.o tcode.o tccomp.o\
                tivals.o t_out.o tfixcd.o t_inlin.o tsrcfls.o tchkinv.o\
		typinfer.o tlifetim.o t_ilanlz.o

COBJS=		../common/long.o ../common/getopt.o ../common/time.o\
		  ../common/filepart.o ../common/memory.o ../common/identify.o\
		  ../common/strtbl.o ../common/rtdb.o ../common/literals.o \
		  ../common/alloc.o ../common/redirerr.o

ICOBJS=		long.o getopt.o time.o filepart.o memory.o identify.o\
		  strtbl.o rtdb.o literals.o alloc.o redirerr.o

all:		common iconc

# common code
common:
		cd ../common; $(MAKE) $(ICOBJS) $(XPM)

iconc:		$(OBJS) $(COBJS)
		$(CC) $(LDFLAGS) -o iconc $(OBJS) $(COBJS)
		cp iconc ../../bin
		strip ../../bin/iconc

$(OBJS):	../h/config.h ../h/cpuconf.h ../h/cstructs.h ../h/define.h\
		../h/proto.h ../h/typedefs.h

$(COBJS):	../h/cproto.h

tmain.o:	globals.h tproto.h
tlocal.o:	../h/config.h
util.o:		globals.h tproto.h
trans.o:	globals.h trans.h tsym.h token.h tree.h
err.o:		trans.h tlex.h token.h tree.h
parse.o:	trans.h tsym.h tree.h tproto.h tlex.h
tlex.o:		trans.h tlex.h token.h tree.h tproto.h
toktab.o:	trans.h tlex.h token.h tproto.h
tmem.o:		globals.h trans.h tsym.h tree.h tproto.h
tree.o:		tree.h tproto.h tlex.h tsym.h token.h
tsym.o:		globals.h trans.h tsym.h token.h tproto.h tree.h
tdbase.o:	trans.h tproto.h globals.h tlex.h tsym.h
tcode.o:	globals.h tproto.h tree.h tsym.h trans.h tcode.h
tccomp.o:	globals.h tproto.h
t_out.o:	trans.h tproto.h globals.h tsym.h tcode.h tree.h
tfixcd.o:	trans.h tproto.h globals.h tcode.h
t_inlin.o:	trans.h tproto.h globals.h tcode.h tsym.h tree.h
tsrcfls.o:	tproto.h trans.h
tchkinv.o:	globals.h trans.h tproto.h tsym.h tree.h token.h
tivals.o:	globals.h tproto.h tsym.h trans.h
typinfer.o:	trans.h tproto.h tsym.h tree.h tlex.h token.h globals.h
tlifetim.o:	trans.h tproto.h tsym.h tree.h tlex.h token.h globals.h
t_ilanlz.o:	trans.h tproto.h globals.h tsym.h tree.h tcode.h



#  The following sections are commented out because they do not need
#  to be performed unless changes are made to icon_g.c, tokens.txt, or
#  op.txt. Such changes involve modifications to the syntax of Icon
#  and are not part of the installation process.  However, if the
#  distribution files are unloaded in a fashion such that their dates
#  are not set properly, the following sections would be attempted.
#
#  Note that if any changes are made to the four files mentioned above,
#  the comment characters at the beginning of the following lines should be
#  removed.

#parse.c token.h:	expanded.g pscript
## expect 214 or 215 shift/reduce conflicts
#			yacc -d expanded.g
#			./pscript <y.tab.c >parse.c
#			mv y.tab.h token.h
#			rm -f y.tab.c
#
#expanded.g:		icon_g.c icon_g.h gdefs.h fixgram ../h/define.h
#			$(CC) -E -C icon_g.c | ./fixgram >expanded.g
#
#toktab.c icon_g.h:	tokens.txt op.txt mktoktab
#			./mktoktab
#
#pscript:		pscript.icn
#			icont -s pscript.icn
#
#mktoktab:		mktoktab.icn
#			icont -s mktoktab.icn
#
#fixgram:		fixgram.icn
#			icont -s fixgram.icn
