MAKE=make

TRANS=		trans.o tcode.o err.o keyword.o tlex.o lnklist.o \
		   optab.o parse.o tsym.o tmem.o toktab.o tree.o

LINKR=		link.o lglob.o lcode.o llex.o lmem.o lsym.o opcode.o

OBJS=		tmain.o util.o tlocal.o $(TRANS) $(LINKR)

COBJS=		../common/long.o ../common/getopt.o ../common/alloc.o \
		   ../common/filepart.o ../common/strtbl.o

ICOBJS=		long.o getopt.o alloc.o filepart.o strtbl.o

PGMS=		iconx.hdr icont

all:		$(PGMS)

hdr.h:		newhdr.c iconx.hdr tproto.h
		$(CC) -o newhdr newhdr.c
		./newhdr <iconx.hdr >hdr.h

common:
		cd ../common; $(MAKE) $(ICOBJS)

icont:		hdr.h iconx.hdr $(OBJS) common
		$(CC) $(CFLAGS) $(LDFLAGS) -o icont $(OBJS) $(COBJS) $(LIBS)
		cp icont ../../bin
		strip ../../bin/icont

$(OBJS):	../h/config.h ../h/proto.h ../h/cproto.h ../h/define.h \
		   ../h/gsupport.h ../h/typedefs.h ../h/cstructs.h tproto.h

tmain.o:	globals.h
util.o:		globals.h link.h lfile.h tree.h trans.h ../h/fdefs.h

# translator files
trans.o:	globals.h trans.h tsym.h token.h tree.h ../h/version.h
err.o:		trans.h tlex.h token.h tree.h
keyword.o:	tsym.h ../h/keyword.h
lnklist.o:	trans.h lfile.h
optab.o:	tlex.h
parse.o:	trans.h tsym.h tree.h ../h/keyword.h
tcode.o:	globals.h trans.h tsym.h token.h tree.h
tlex.o:		trans.h tlex.h token.h tree.h
toktab.o:	trans.h tlex.h token.h
tmem.o:		globals.h trans.h tsym.h tree.h
tree.o:		tree.h
tsym.o:		globals.h trans.h lfile.h tsym.h token.h

# linker files
$(LINKR):	link.h lfile.h ../h/rt.h ../h/cpuconf.h
link.o:		globals.h ../h/header.h hdr.h
lcode.o:	globals.h opcode.h ../h/header.h \
			../h/keyword.h ../h/opdefs.h ../h/version.h
lglob.o:	opcode.h ../h/opdefs.h ../h/version.h
llex.o:		globals.h opcode.h ../h/opdefs.h ../h/cpuconf.h
lmem.o:		globals.h
lsym.o:		globals.h
opcode.o:	opcode.h ../h/opdefs.h


# header file for executables
iconx.hdr:	ixhdr.o
		$(CC) $(LDFLAGS) $(CFLAGS) $(HFLAGS) ixhdr.o \
			-o iconx.hdr $(LIBS)
		strip iconx.hdr
ixhdr.o:	../h/gsupport.h ../h/define.h ../h/header.h


#
#  The following sections are commented out because they do not need to be
#  performed unless changes are made to icon_g.c, keywords.txt, tokens.txt, or
#  optab.txt.  Such changes involve modifications to the syntax of Icon
#  and are not part of the installation process.  However, if the
#  distribution files are unloaded in a fashion such that their dates
#  are not set properly, the following sections would be attempted.
#
#  Note that if any changes are made to the four files mentioned above,
#  the comment characters at the beginning of the following lines should be
#  removed.
#
#  Note that icont must be on your search path for this.
#
#parse.c token.h:	expanded.g trash pscript
## expect 219 shift/reduce conflicts
#			yacc -d expanded.g
#			./trash <y.tab.c | ./pscript >parse.c
#			mv y.tab.h token.h
#			rm -f y.tab.c
#
#expanded.g:		icon_g.c gdefs.h fixgram ../h/define.h
#			$(CC) -E -C icon_g.c | ./fixgram >expanded.g
#
#keywords.txt:		key_text.c ../h/define.h
#			$(CC) -E -C key_text.c >keywords.txt
#
#../h/keyword.h keyword.c:  keywords.txt mkkeytab
#			./mkkeytab
#
#toktab.c optab.c:	tokens.txt optab.txt mktoktab
#			./mktoktab
#
#pscript:		pscript.icn
#			icont -s pscript.icn
#
#trash:			trash.icn
#			icont -s trash.icn
#
#mkkeytab:		mkkeytab.icn
#			icont -s mkkeytab.icn
#
#mktoktab:		mktoktab.icn
#			icont -s mktoktab.icn
#
#fixgram:		fixgram.icn
#			icont -s fixgram.icn
