MAKE=make

OBJS=		cat.o err.o optab.o parse.o tlex.o tmem.o toktab.o trans.o \
		   tlocal.o tree.o tsym.o vtmain.o util.o variant.o

HDRS=		../h/gsupport.h ../h/define.h ../h/config.h ../h/typedefs.h \
		   ../h/cstructs.h ../h/proto.h ../h/cpuconf.h tproto.h \
		   trans.h

COBJS=		../common/getopt.o  ../common/alloc.o \
                   ../common/filepart.o ../common/strtbl.o

../vitran:	$(OBJS)
		$(CC) $(LDFLAGS) -o ../vitran $(OBJS) $(COBJS)

$(OBJS):	$(HDRS)

cat.o:		tree.h ../cat.c
		$(CC) -c $(CFLAGS) ../cat.c

variant.o:	tree.h ../variant.c
		$(CC) -c $(CFLAGS) ../variant.c

err.o:		tlex.h token.h tree.h
optab.o:	tlex.h
parse.o:	tsym.h tree.h ../h/keyword.h
tlex.o:		tlex.h token.h tree.h
tmem.o:		globals.h tsym.h tree.h
toktab.o:	tlex.h token.h
trans.o:	globals.h tsym.h token.h tree.h ../h/version.h
tree.o:		tree.h
tsym.o:		globals.h lfile.h tsym.h token.h
util.o:		globals.h tree.h ../h/fdefs.h
vtmain.o:	globals.h

parse.c token.h:	expanded.g trash pscript
			yacc -d expanded.g   # expect 219 shift/reduce conflicts
			./trash <y.tab.c | ./pscript >parse.c
			mv y.tab.h token.h
			rm -f y.tab.c

expanded.g:		icon_g.c gdefs.h fixgram
			cc -E -C icon_g.c | ./fixgram >expanded.g

gdefs.h:		../bsyms ../usyms ../ident.defs ../variant.defs
			cd ..; ./define ident.defs variant.defs >itran/gdefs.h

toktab.c optab.c:	tokens.txt optab.txt mktoktab
			./mktoktab

define:			define.icn
			icont -s define.icn

trash:			trash.icn
			icont -s trash.icn

pscript:		pscript.icn
			icont -s pscript.icn

mktoktab:		mktoktab.icn
			icont -s mktoktab.icn

fixgram:		fixgram.icn
			icont -s fixgram.icn
