!
! Run a list of Icon tests using the compiler.
! p1 = directory containing tests
! p2 = name of file containing list
! p3 = name of "local" directory
! p4 = name of "stand" directory
! p5-p7 = arguments to iconc (optional)
!
$ @[-.bin]deficon
$ set noon
$ on control_y then $ goto done
$
$ set default [.'p1']
$ open/read tlist 'p2'.lst
$ write sys$output "Running ''p2' tests:"
$loop:
$ read/end=done tlist name
$ write sys$output " Compiling ''name'"
$ if p7 .nes. ""
$ then iconc -s 'p5' 'p6' 'p7' 'name'.icn
$ else if p6 .nes. ""
$      then iconc -s 'p5' 'p6' 'name'.icn
$      else if p5 .nes. ""
$           then iconc -s 'p5' 'name'.icn
$           else iconc -s 'name'.icn
$           endif
$      endif
$ endif
$ write sys$output " Running ''name'"
$ define/user sys$output [.'p3']'name'.out
$ define/user sys$error  [.'p3']'name'.err
$ if f$search("''name'.dat") .nes. "" then $ define/user sys$input 'name'.dat
$ run 'name'.exe
$ write sys$output " Checking ''name'"
$ append [.'p3']'name'.err [.'p3']'name'.out
$ diff/output=[.'p3'] [.'p3']'name'.out [.'p4']'name'.out
$ if (($status .and. 7) .ne. 1) then $ goto failed
$ delete/noconfirm/nolog [.'p3']'name'.*;*
$ goto loop
$failed:
$ write sys$output "   --- output differs"
$ goto loop
$done:
$ close tlist
$ set default [-]
$
$ exit 1
