/*  This program reads Icon onto a VMS system for building a release tape.
 *  (So how doest the program get there in the first place?  email, natch.  */

 

/*  cpi.c - copy in (from cpio tape)
 *
 *  a very simple cpio file unpacker.
 *  assumes the cpio file, from standard input, was created with -c.
 *  all files are written unconditionally, and no attributes are preserved.
 *
 *  24-mar-86 gmt
 */



#include <stdio.h>
#ifdef VMS
#define rindex strrchr
#endif

#define HDRSIZE 76                      /* CPIO header size */
#define NAMSIZE 300                     /* max file name size */
#define BUFSIZE 20000                   /* buffer size */
#define DIRMODE 0                       /* mode for new directories */
#define FALLBACK "orphans.dat"          /* data sink for unwritable files */



/*  main program  */

main()
{
    int magic, dev, ino, mode, uid, gid, nlink, rdev, namesize;
    long mtime, filesize;
    char header[HDRSIZE+1], fname[NAMSIZE], buf[BUFSIZE];
    int n;
    FILE *ofile;

    header[HDRSIZE] = '\0';
    while (fread(header,HDRSIZE,1,stdin))  {    /* while another header */
        n = sscanf(header,"%6o%6o%6o%6o%6o%6o%6o%6o%11lo%6o%11lo",
            &magic, &dev, &ino, &mode, &uid, &gid, &nlink, &rdev,
            &mtime, &namesize, &filesize);
        if (n < 11 || magic != 070707)          /* check header for validity */
            { fprintf(stderr,"bad header\n"); exit (1); }
        fread(fname,namesize,1,stdin);          /* read file name */
        if (!strcmp(fname,"TRAILER!!!"))        /* quit if end of good data */
            exit(0);
        parent(fname);                          /* make parent directory */
        if (!(ofile = fopen(fname,"w"))) {      /* open file */
            perror(fname);
            if (!(ofile = fopen(FALLBACK,"a")))  {
                perror(FALLBACK);
                exit(1);
            }
            fprintf(stderr,"appending data to %s\n",FALLBACK);
            fprintf(ofile,"---------- %s ----------\n",fname);
        } else
            fprintf(stderr,"%s\n",fname);       /* note it */
        while (filesize)  {                     /* copy file contents */
            n = filesize;
            if (n > BUFSIZE)
                n = BUFSIZE;
            if (!fread(buf,n,1,stdin))
                { fprintf(stderr,"file truncated"); exit(1); }
            fwrite(buf,n,1,ofile);
            filesize -= n;
        }
        fclose(ofile);
    }
    fprintf(stderr,"<EOF>\n");
}



/*  parent(fname) - make the directory containing fname
 *
 *  failure is ignored; the directory may already exist.
 *  problems will be caught soon enough at file open time.
 */

parent(fname)
char *fname;
{
    static char lastdir[NAMSIZE] = "";
    char *p;
    char *rindex();

    if (!(p = rindex(fname,'/')))               /* if no / in name, return */
        return;
    if (!strncmp(lastdir,fname,p-fname+1))      /* if made it earlier, return */
        return;
    *p = '\0';                                  /* make name of parent */
    parent(fname);                              /* make ITS parent directory */
    mkdir(fname,DIRMODE);                       /* make this one */
    *p = '/';                                   /* restore name */
    strcpy(lastdir,fname);                      /* keep a record */
}
