#if !COMPILER
#if IconCalling
/*
 *  Demonstration program to call an Icon procedure with arguments.  This
 *  program is used as
 *
 *	iconval iprog proc arg1 arg2 ...
 *
 *  where iprog is the name of the Icon icode file, proc is the name of
 *  a procedure in it, and arg1, arg2, ... are arguments passed to proc.
 *  It prints out the result if proc succeeds or notes if the procedure fails.
 *  It prints a diagnostic message if proc is not a procedure in iprog.
 */

extern int call_error;

novalue main(argc,argv)

int argc;
char *argv[];
   {
   int clargc;
   char **clargv;
   dptr retval, iargv;
   int i;
   char sbuf[MaxCvtLen];

   /*
    * Read in the icode file argv[1] and initialize the Icon system.
    *  This must be done for any C program calling Icon.
    */
   icon_init(argv[1]);

   /*
    * Skip the names of the executable and the file it processes.  It
    *  is only necessary to get the the procedure name and its arguments from
    *  the command line.
    */
   clargv = argv + 2;
   clargc = argc - 3;

   fprintf(stderr,"program=%s\n",*clargv);
   fflush(stderr);
   /*
    * Malloc space for the list of descriptors and create Icon qualifiers
    *  for each argument.
    */
   iargv = (dptr)malloc(clargc * sizeof(struct descrip));
   for (i = 0; i < clargc; i++) {
      StrLoc(iargv[i]) = clargv[i + 1];
      StrLen(iargv[i]) = strlen(clargv[i + 1]);
     } 
   retval = icon_call(*clargv, clargc, iargv);
   if (call_error) {
      fprintf(stderr,"procedure not found\n");
      fflush(stderr);
      c_exit(ErrorExit);
      }
   if (retval == NULL)
      fprintf(stdout,"evaluation failed\n");
   else {
      /* Check type of result returned.  Don't attempt to print anything
       *  but strings and integers here.
       */
      if (Qual(*retval)) {
        qtos(retval,sbuf);
        fprintf(stdout,"\"%s\"\n",sbuf);
        }
      else if (Type(*retval) == T_Integer)
        fprintf(stdout,"%ld\n",IntVal(*retval));
      else
        fprintf(stdout,"type=%d\n",Type(*retval));
      fflush(stdout);
      }
   c_exit(NormalExit);

   }
#else					/* IconCalling */
static char x;			/* avoid empty module */
#endif					/* IconCalling */
#endif					/* !COMPILER */
