#include "../h/gsuppport.h"
#include "itran/tproto.h"
#include "itran/tree.h"

/* N_SUBSTR determines the number of elements in a string list */
#define N_SUBSTR(x) (TType((x)) == N_Binop ? (x)->n_field[2].n_val : 1)

/* q - convert a string into a list of one element */
nodeptr q(s)
char *s;
{
    return StrNode(s, (int)strlen(s));
} 

/* concatenate n string lists using a binary tree representation */
nodeptr cat(n, slist, p2, p3, p4, p5, p6, p7, p8, p9)
int n;
nodeptr slist;
int p2, p3, p4, p5, p6, p7, p8, p9;

{
    nodeptr *p;
    nodeptr catstr;
    int size;

    catstr = slist;
    size = N_SUBSTR(catstr);
    for (p = &slist + 1; --n; ++p) {
	size += N_SUBSTR(*p);
	catstr = tree5(N_Binop, *p, catstr, *p, (nodeptr)size);
	}
    return catstr;
}

/* item - return the nth item in the given list */
nodeptr item(slist, n)
nodeptr slist;
int n;
{
    int lsize;

    if (TType(slist) == N_Binop) {
	if ((lsize  = N_SUBSTR(Tree0(slist))) >= n)
	    return item(Tree0(slist), n);
	else
	    return item(Tree1(slist), n - lsize);
	}
    else {
	if (n == 1)
	    return slist;
	else
	    return NULL;
	}
}

treeprt(x)
nodeptr x;
{
    if (TType(x) == N_Binop) {
	treeprt(Tree0(x));
	treeprt(Tree1(x));
	}
    else
	printf("%s", Str0(x));
}
